package pacman3d.message;

/**
 * <p>Title:     Praktikum Java3D und VRML </p>
 * Description:  <p>die Klasse nimmt Informationen vom Labyrinth auf, die es
 *               per Nachricht an bestimmte Elemente verschicken mchte (z. B.
 *               die Anzahl der noch verbliebenen Score-Items)</p>
 * Copyright:    Copyright (c) 2001-2002<br>
 *
 * @author Labyrinth-Gruppe<br/>
 * @version $Version$ $Date: 2002/03/04 05:41:25 $<br/>
 */

public class LabyrinthInfoContent implements java.io.Serializable{

	/** current number of times killed */
	private long m_iItemsLeftCount;

	/**
	 * der nackte Konstruktor
	 */
	public LabyrinthInfoContent () {
		m_iItemsLeftCount = 0;
	}

	/**
	 * Konstruktor nimmt auch gleich die Anzahl von Score-Items entgegen,
	 * der verschickt werden soll
	 * @param iItemsLeftCount die Anzahl der brigen Score-Items
	 */
	public LabyrinthInfoContent (long iItemsLeftCount) {
		m_iItemsLeftCount = iItemsLeftCount;
	}

	/**
	 * gibt die Anzahl der Score-Items zurck, die noch im Level liegen
	 * @return die Anzahl der Items
	 */
	public long getItemsLeftCount() {
		return m_iItemsLeftCount;
	}

}