package pacman3d.util;

/**
 * <b>Title:</b>      	Pacman 3D - Nicht wirklich ;)</br>
 * <b>Description:</b><br>
 *
 * Die Klasse enthlt Konstanten und Informationen ber den Aufbau einer
 * Leveldatei im XML-Format, die von Parser und Generator zum Laden und
 * Speichern von Levels verwendet werden.<br>
 *
 * <b>Copyright:</b>	Copyright (c) 2001-2002<br>
 *
 * @author              Labyrinth-Gruppe<br>
 * @version             06.01.2002<br>
 */

public class LevelXmlSyntax {

	/* Konstanten fr die obersten xml-Tags im levelfile */
	public static String TAG_GAMELEVEL = "gamelevel";
	public static String TAG_COMMON = "common";
	public static String TAG_RESOURCES = "resources";
	public static String TAG_CELLTYPES = "celltypes";
	public static String TAG_ITEMTYPES = "itemtypes";
	public static String TAG_LEVELSTRUCTURE = "levelstructure";

	/* Konstanten fr allgemein verwendete Attributnamen */
	public static String ATTR_ID = "id";
	public static String ATTR_TYPE = "type";
	public static String ATTR_NAME = "name";

	/* Konstanten fr die Kinderelemente des <levelstructure>-Elements */
	public static String TAG_FLOORS = "floors";
	public static String TAG_FLOOR = "floor";
	public static String TAG_CELL = "cell";
	public static String ATTR_ROWS = "rows";
	public static String ATTR_COLS = "cols";
	public static String ATTR_GRAVITY = "gravity";
	public static String TAG_PACMANS = "pacmen";
	public static String TAG_MONSTERS = "monsters";
	public static String TAG_PACMAN = "pacman";
	public static String TAG_MONSTER = "monster";
	public static String TAG_STARTPOSITION = "startposition";
	public static String TAG_LINEOFSIGHT = "lineofsight";
	public static String ATTR_X = "x";
	public static String ATTR_Y = "y";
	public static String ATTR_Z = "z";

        /* Konstanten fr Kinderelemente von <monster>-Elementen */
        public static String TAG_MONSTER_STRATEGIE = "strategie";
        public static String TAG_MONSTER_SETUP_FENSTER = "setupfenster";
        public static String TAG_MONSTER_MODELL = "modell";

        /* Konstanten fr Kinderelemente von <cell>-, <celltype>- und <itemtype>-Elementen */
	public static String TAG_ITEMS = "items";
	public static String TAG_CELLTYPE = "celltype";
	public static String TAG_ITEMTYPE = "itemtype";
	public static String TAG_PARAMS = "params";
	public static String TAG_RESOURCELINK = "rsrclink";
	public static String TAG_TEX = "texture";
	public static String ATTR_TEX_SIDE = "side";
	public static String ATTR_JAVACLASS = "javaclass";
	public static String TAG_ITEM = "item";

	/* Und die entsprechenden Attribute */
	public static String ATTR_RESOURCELINK_HREF = "xlink:href";

	/* testcomment */


	/**
	 * zur Zeit wird noch nicht viel konstruiert hier, aber mglicherweise
	 * werden spter einige Klassenvariablen gesetzt.
	 */
	public LevelXmlSyntax() {
	}
}